#!/bin/sh
#------------------------------------------------------------------------------
# /tmp/preinstall.sh - pre-installation file for mini_httpd module
#
# Copyright (c) 2003-2010 Andreas Pohl, apohl(at)ibp-consult(dot)com
# Copyright (c) 2011      The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2003-12-30 ap
# Last Update:  $Id: preinstall.sh 28449 2011-05-29 10:05:47Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

# include eislib etc.
. /var/install/include/eislib

old_module_name='sitecopy'
module_name='mini_httpd_sitecopy'

mecho --info "running preinstall.sh ..."

old_configfile=/etc/config.d/${old_module_name}
configfile=/etc/config.d/${module_name}
installfile=/var/run/${module_name}.install
old_deinstallfile=/var/install/deinstall/${old_module_name}
deinstallfile=/var/install/deinstall/${module_name}

if [ ! -f /var/install/packages/mini_httpd ]
then
    mecho --error "Installation of ${module_name} failed. You have to install mini_httpd!"
    mecho --error "Install it from http://www.pack-eis.de/."
    exit 1
fi

if [ -f ${old_deinstallfile} ]
then
    mecho "saving previous configuration file to ${installfile} ..."
    cp ${old_configfile} ${installfile}

    # delete legacy package
    mecho "deinstalling previously installed software ..."
    /var/install/bin/del-package -p ${old_module_name} update > /dev/null 2> /dev/null

    # delete legacy menue entry
    /var/install/bin/del-menu /var/install/bin/setup.services.mini_httpd.module.${old_module_name} \
        /var/install/menu/setup.services.mini_httpd.module.menu
elif [ -f ${deinstallfile} ]
then
    mecho "saving previous configuration file to ${installfile} ..."
    cp ${configfile} ${installfile}

    mecho "deinstalling previously installed software ..."
    /var/install/bin/del-package -p ${module_name} --update
fi

exit 0
