#!/bin/sh
#------------------------------------------------------------------------------
# /usr/local/htdocs/sitecopy/sitecopy.cgi - smart copy of local site to remote
#                                           site via ftp
#
# Copyright (c) 2003-2010 Andreas Pohl, apohl(at)ibp-consult(dot)com
# Copyright (c) 2011      The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2003-12-30 ap
# Last Update:  $Id: sitecopy.cgi 28176 2011-04-27 22:12:21Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

myname=`basename $0`

# HTML-Header
echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo
echo "<html><head>"
echo "<title>SiteCopy</title>"
echo "<LINK REL=STYLESHEET TYPE="text/css" HREF="../main.css">"
echo "</head>"

echo "<body>"
echo "<h2>SiteCopy - smart ftp uploader</h2>"
echo "<hr>"

. /etc/config.d/mini_httpd_sitecopy

idx=1
if [ "${START_SITECOPY}" = "yes" ]
then
    if [ ${SITECOPY_N} -ge ${idx} ]
    then
        echo '<table border="0" width="100%">'
        echo '<tr>'
        echo '    <td>All Sites</td>'
        echo "    <td><input name=\"test_all\" type=\"button\" value=\"TEST\" style=\"width: 80px\"
                          onclick=\"location.href='${myname}?path=-a&param=-l'\" title=\"Test all sites.\">"

        echo "        <input name=\"update_all\" type=\"button\" value=\"UPDATE\" style=\"width: 80px\"
                      onclick=\"location.href='${myname}?path=-a&param=-u'\" title=\"Update all sites.\">"
        echo '        <br></td>'
        echo '</tr>'

        idx=1
        while [ ${idx} -le ${SITECOPY_N} ]
        do
            eval active='$SITECOPY_'${idx}'_ACTIVE'

            if [ "${active}" = "yes" ]
            then
                eval pfad='$SITECOPY_'${idx}'_NAME'

                echo "<tr><td>${pfad}</td>"
                echo "    <td><input name=\"${pfad}_view\" type=\"button\" value=\"VIEW\" style=\"width: 80px\"
                              onclick=\"location.href='${myname}?path=${pfad}&param=-v'\" title=\"View ${pfad} configuration.\">"

                echo "        <input name=\"${pfad}_init\" type=\"button\" value=\"INIT\" style=\"width: 80px\"
                              onclick=\"location.href='${myname}?path=${pfad}&param=-i'\" title=\"Init ${pfad} configuration.\">"

                echo "        <input name=\"${pfad}_fetch\" type=\"button\" value=\"FETCH\" style=\"width: 80px\"
                              onclick=\"location.href='${myname}?path=${pfad}&param=-f'\" title=\"Fetch files from ${pfad}.\">"

                echo "        <input name=\"${pfad}_verify\" type=\"button\" value=\"VERIFY\" style=\"width: 80px\"
                              onclick=\"location.href='${myname}?path=${pfad}&param=-e'\" title=\"Verify ${pfad} site.\">"

                echo "        <input name=\"${pfad}_test\" type=\"button\" value=\"TEST\" style=\"width: 80px\"
                              onclick=\"location.href='${myname}?path=${pfad}&param=-l'\" title=\"Test ${pfad} site.\">"

                echo "        <input name=\"${pfad}_update\" type=\"button\" value=\"UPDATE\" style=\"width: 80px\"
                              onclick=\"location.href='${myname}?path=${pfad}&param=-u'\" title=\"Update ${pfad} site.\"></td>"
                echo '</tr>'
            fi

            idx=`expr ${idx} + 1`
        done

        echo '</tr></table>'
    else
        echo "No directories assigned. Please check config."
    fi
else
    echo "Cnofiguration has been disabled, please check the configuration."
fi

echo '<p><small>'
echo "<input name=\"refresh\" type=\"button\" value=\"REFRESH\" style=\"width: 80px\"
          onclick=\"window.location.reload()\" title=\"Refresh page.\">"

idx=1
while [ ${idx} -le ${SITECOPY_LINK_N} ]
do
    eval l_active='$SITECOPY_LINK_'${idx}'_ACTIVE'

    if [ "${l_active}" = "yes" ]
    then
        eval l_name='$SITECOPY_LINK_'${idx}'_NAME'
        eval l_href='$SITECOPY_LINK_'${idx}'_HREF'
        eval l_target='$SITECOPY_LINK_'${idx}'_TARGET'
        echo " | <a href=\"${l_href}\" target=\"${l_target}\">${l_name}</a>"
    fi

    idx=`expr ${idx} + 1`
done

echo "</small><p><hr>"

case "${QUERY_STRING}" in
    (path=*)
        echo "<h4>Start: "
        date +"%a, %d.%m.%Y %H:%M:%S"
        echo "</h4>"

        echo "<pre>"
        eval `echo "${QUERY_STRING}" |tr '&' '\n'`
        ./upload.sh "${path}" "${param}"
        echo "</pre>"

        echo "<h4>Ende: "
        date +"%a, %d.%m.%Y %H:%M:%S"
        echo "</h4>"
        echo "<hr>"
esac

echo "</body></html>"
exit 0
